/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.pv;

import gov.anl.aps.irmis.persistence.BaseDAO;
import gov.anl.aps.irmis.persistence.DAOException;

import java.util.List;

/**
 * Methods for explicitly finding all IRMIS iocs and instantiating
 * <code>IOC</code> objects from them.
 */
public class IOCDAO extends BaseDAO {

    /**
     * Do nothing constructor.
     */
    public IOCDAO() throws DAOException {
        super();
    }

    /**
     * Find set of all ioc's from ioc table.
     * 
     * @return list of <code>IOC</code> objects
     * @throws DAOException
     */
    public List findIOCs() throws DAOException {
        return retrieveObjs("from IOC i order by i.iocName",null,null);
    }

}
