/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.pv;

import gov.anl.aps.irmis.persistence.BaseDAO;
import gov.anl.aps.irmis.persistence.DAOException;

import net.sf.hibernate.type.Type;
import net.sf.hibernate.Hibernate;
import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Criteria;
import net.sf.hibernate.FetchMode;
import net.sf.hibernate.expression.Expression;

import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

/**
 * Methods for explicitly finding IRMIS process variable records types and
 * instantiating <code>RecordType</code> objects from them. 
 */        
public class RecordTypeDAO extends BaseDAO {

    /**
     * Do nothing constructor
     */
    public RecordTypeDAO() throws DAOException {
        super();
    }

    /**
     * Find single <code>RecordType</code> for given primary key id.
     *
     * @param recTypeId primary key id for a given record type
     * @throws DAOException
     */
    public RecordType findByRecordTypeId(Long recTypeId) throws DAOException {
        String query = "from RecordType rt join fetch rt.fieldTypes where rt.id = ?";
        Long[]values = {recTypeId};
        Type[]types = {Hibernate.LONG};
        return (RecordType)retrieveObj(query,values,types);
    }

}
