package gov.anl.aps.irmis.persistence.test;

import java.util.Iterator;
import java.util.List;
import java.util.Set;

import gov.anl.aps.irmis.persistence.HibernateUtil;
import gov.anl.aps.irmis.persistence.DAOException;
import gov.anl.aps.irmis.persistence.pv.IOC;
import gov.anl.aps.irmis.persistence.pv.IOCBoot;
import gov.anl.aps.irmis.persistence.pv.IOCResource;
import gov.anl.aps.irmis.persistence.pv.RecordType;
import gov.anl.aps.irmis.persistence.pv.IOCBootDAO;
import gov.anl.aps.irmis.persistence.pv.IOCResourceDAO;

import junit.framework.Assert;
import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
   Test of efficient loading of ioc boot info and associated resources.
*/

public class BootAndResourceTest extends TestCase {

    private IOCBootDAO ibDAO;
    private IOCResourceDAO irDAO;
    static Log log = LogFactory.getLog(BootAndResourceTest.class.getName());

    public BootAndResourceTest(String name) {
        super(name);
        try {
            ibDAO = new IOCBootDAO();
            irDAO = new IOCResourceDAO();
        } catch (DAOException de) {}
    }

    /**
       Selects all current ioc boot records that are "current_load = 1". Also
       pulls in all related IOCResource and URI objects via iteration.
    */
    public void testBootAndResources() {
        try {
            List iocBoots = ibDAO.findCurrentLoads();

            if (iocBoots != null) {
                Iterator iocBootIt = iocBoots.iterator();
                while (iocBootIt.hasNext()) {
                    IOCBoot iocBoot = (IOCBoot)iocBootIt.next();
                    log.info("found ioc "+iocBoot.getIoc().getIocName());
                    // load up it's resources and show them
                    List iocResources = irDAO.findByIOCBootId(iocBoot.getId());
                    
                    // try getting to them via original object now
                    Set irSet = iocBoot.getIocResources();
                    log.info("has "+irSet.size()+" resources");
                    Iterator irIt = irSet.iterator();
                    while (irIt.hasNext()) {
                        IOCResource ir = (IOCResource)irIt.next();
                        String uri = ir.getUri().getUri();
                    }
                }

            } else {
                Assert.fail("Unable to locate current ioc loads");
            }
        }
        catch (Exception e) {
            Assert.fail(e.getMessage());
        }
        finally {
            HibernateUtil.closeSession();
        }
    }

}
