package gov.anl.aps.irmis.persistence.test;

import java.util.Iterator;
import java.util.List;

import gov.anl.aps.irmis.persistence.HibernateUtil;
import gov.anl.aps.irmis.persistence.DAOException;
import gov.anl.aps.irmis.persistence.pv.IOC;
import gov.anl.aps.irmis.persistence.pv.IOCBoot;
import gov.anl.aps.irmis.persistence.pv.IOCResource;
import gov.anl.aps.irmis.persistence.pv.RecordType;
import gov.anl.aps.irmis.persistence.pv.IOCBootDAO;

import junit.framework.Assert;
import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
   Test class for the IOCBootDAO class.
*/

public class IOCBootDAOTest extends TestCase {

    private IOCBootDAO dao;
    static Log log = LogFactory.getLog(IOCBootDAOTest.class.getName());

    public IOCBootDAOTest(String name) {
        super(name);
        try {
            dao = new IOCBootDAO();
        } catch (DAOException de) {}
    }

    /**
       Selects all current ioc boot records that are "current_load = 1". Also
       pulls in all related IOCResource and URI objects.
    */
    public void testFindCurrentLoads() {
        try {
            List iocBoots = dao.findCurrentLoads();

            if (iocBoots != null) {
                Iterator iocBootIt = iocBoots.iterator();
                while (iocBootIt.hasNext()) {
                    IOCBoot iocBoot = (IOCBoot)iocBootIt.next();
                    log.info("found ioc "+iocBoot.getIoc().getIocName());
                }

            } else {
                Assert.fail("Unable to locate current ioc loads");
            }
        }
        catch (Exception e) {
            Assert.fail(e.getMessage());
        }
        finally {
            HibernateUtil.closeSession();
        }
    }

}
