package gov.anl.aps.irmis.persistence.test;

import java.util.Iterator;
import java.util.List;

import gov.anl.aps.irmis.persistence.DAOException;
import gov.anl.aps.irmis.persistence.pv.IOC;
import gov.anl.aps.irmis.persistence.pv.IOCDAO;

import junit.framework.Assert;
import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
   Test class for the IOCDAO class.
*/

public class IOCDAOTest extends TestCase {

    private IOCDAO dao;
    static Log log = LogFactory.getLog(IOCDAOTest.class.getName());

    public IOCDAOTest(String name) {
        super(name);
        try {
            dao = new IOCDAO();
        } catch (DAOException de) {}
    }

    /**
       Selects all iocs from the database.  This test will
       fail if there are no iocs in the database.
    */
    public void testSelectIOCs() {
        try {
            List iocs = dao.findIOCs();
            log.info("Number of iocs retrieved from database: "+iocs.size());

            if (iocs.size() == 0) {
                Assert.fail("No iocs were found in the database.");
            }

        }
        catch (Exception e) {
            Assert.fail(e.getMessage());
        }
    }

}


